from string import join

class restriction:
    def __init__(self,xml):
        self.XMLname=xml.tagName
        self.translations={'node-software':{'tag':"nodesoftware.node=tag.node"}}
        self.fields=[]
        self.visible=[]
        self.restrictions=[]
        self.rows=[] # These will correspond to fields
        if xml.childNodes:
            self.table=join([xml.tagName.replace('-','')]+map(lambda x:x.tagName,filter(lambda x:x.nodeType == 1,xml.childNodes)),',')
            selectionlist=[]
            for node in [xml]+xml.childNodes:
                 complexity=0
                 jcrit=[]
                 self.restrictions=[]
                 if node.hasAttribute('match'):#complexity checking
                     if (node.getAttribute('match')=='complex'):
                         complexity=1
                 for (attr,value) in node._get_attributes().items():
                     if attr!='match':
                         fullattr="%s.%s"%(node.tagName.replace('-',''),attr)
                         if value != '*':
                             self.restrictions.append((fullattr,value,complexity))
                         self.fields.append(fullattr)
                         self.visible.append(fullattr)
                 if self.translations.has_key(xml.tagName):
                     for node in xml.childNodes:
                         if self.translations[xml.tagName].has_key(node.tagName):
                             jcrit.append(self.translations[xml.tagName][node.tagName])
                 selectionlist.append(join(map(self.MakeSQL,self.restrictions)+jcrit,' and '))
                        
            self.restsql=join(selectionlist[1:len(selectionlist)],' or ')#note AND gets precedence over OR in the DB.
        else:
            self.table=xml.tagName.replace('-','')
            complexity=0
            if xml.hasAttribute('match'):#complexity checking
                if (xml.getAttribute('match')=='complex'):
                    complexity=1
            for (attr,value) in xml._get_attributes().items():
                if value != "*":
                    # Then this is a spec
                    if attr!='match':
                        self.restrictions.append((attr,value,complexity))
                        self.fields.append(attr)
                        self.visible.append(attr)
            self.restsql=join(map(self.MakeSQL, self.restrictions),' and ')

    def SetRows(self,rows):
        self.rows=rows

    def GetSQL(self):
        fields=join(self.fields,',')
        if self.restsql:
            query="SELECT %s from %s where %s;"
            return query%(fields,self.table,self.restsql)
        else:
            return "SELECT %s from %s;"%(fields,self.table)

    def SetSQL(self):
        if self.restsql:
            return "UPDATE %s set %%s where %s;"%(self.table,self.restsql)
        else:
            return "UPDATE %s set %%s;"%(self.table)

    def AddSQL(self):
        query="INSERT into %s (%s) VALUES (%s);"
        fields=map(lambda x:x[0],self.restrictions)
        values=map(lambda y:"'%s'"%y,map(lambda x:x[1],self.restrictions))
        return query%(self.table,join(fields,','),join(values,','))

    def DelSQL(self):
        if self.restsql:
            query="DELETE from %s where %s;"
            return query%(self.table,self.restsql)
        else:
            return "DELETE from %s;"%(self.table)
    
    def GetXML(self):
        creator=Document()
        ret=[]
        data=self.GetFields(self.visible)
        for row in data:
            xe=creator.createElement(self.XMLname)
            for idx in xrange(len(self.visible)):
                xe.setAttribute(self.visible[idx],str(row[idx]))
                ret.append(xe)
        return ret

    def GetField(self,field):
        fidx=self.fields.index(split(field,'.')[0])
        return map(lambda x:x[fidx], self.rows)

    def GetFields(self,flist):
        idxlist=map(lambda x:self.fields.index(x),map(lambda x:split(x,'.')[0],flist))
        return map(lambda y:tuple(map(lambda x:y[x],idxlist)), self.rows)

    def MakeSQL(self,theRestrictions):
        SQLstatement=""
        if theRestrictions[2]==0:#<--complexity
            SQLstatement="%s='%s'"%(theRestrictions[0],theRestrictions[1])
        else:
            if (theRestrictions[1])[0:2]=='!r':
                SQLstatement="%s NOT REGEXP '%s'"%(theRestrictions[0],(theRestrictions[1])[4:(len(theRestrictions[1])+1)])
            elif (theRestrictions[1])[0:2]=='!l':
                SQLstatement="NOT (%s < %s)"%(theRestrictions[0],(theRestrictions[1])[4:(len(theRestrictions[1])+1)])
            elif (theRestrictions[1])[0:2]=='!g':
                SQLstatement="NOT (%s > %s)"%(theRestrictions[0],(theRestrictions[1])[4:(len(theRestrictions[1])+1)])
            elif(theRestrictions[1])[0:2]=='!e': 
                SQLstatement="%s != '%s'"%(theRestrictions[0],(theRestrictions[1])[4:(len(theRestrictions[1])+1)])
            elif (theRestrictions[1])[0:2]=='re':
                SQLstatement="%s REGEXP '%s'"%(theRestrictions[0],(theRestrictions[1])[3:(len(theRestrictions[1])+1)])
            elif (theRestrictions[1])[0:2]=='lt':
                SQLstatement="%s < %s"%(theRestrictions[0],(theRestrictions[1])[3:(len(theRestrictions[1])+1)])
            elif (theRestrictions[1])[0:2]=='gt':
                SQLstatement="%s > %s"%(theRestrictions[0],(theRestrictions[1])[3:(len(theRestrictions[1])+1)])
            else: #this case handles "eq" as well
                SQLstatement="%s = '%s'"%(theRestrictions[0],(theRestrictions[1])[3:(len(theRestrictions[1])+1)])
        return SQLstatement
