#!/usr/bin/env python

from exceptions import ValueError
from sys import argv,exit
from time import localtime, mktime, strftime, time
from xml.dom.minidom import Document

from sss.ssslib import comm_lib

try:
    num=int(argv[-1])
except ValueError:
    print "usage:"
    print "embench.py [number]"
    exit(1)

comm=comm_lib()

h=comm.ClientInit('event-manager')

event='''<?xml version="1.0" ?>
<add-event><event component="foo" data="baz" msg="bar" time="%s"/></add-event>'''
success='''<events><event component="foo" data="baz" msg="bar" time="%s"/></events>'''

start=localtime()
stime=time()
print "Starting at %s"%(strftime("%c",start))

for i in xrange(num):
    mytime=strftime("%c",localtime())
    comm.SendMessage(h,event%(mytime))
    resp=comm.RecvMessage(h)
    if resp != success%mytime:
        print "got bad response: %s"%(resp)

end=localtime()
etime=time()
print "Finished at %s"%(strftime("%c",end))
print "Total Time: %s seconds"%(etime-stime)

comm.ClientClose(h)
