#include<ssslib.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct mangling_memfrob_state {
  int debug;
};

void *mangling_memfrob_LTX_mangling_getstate(SSS_ConfigDict cfg,int debug){
  struct mangling_memfrob_state *ret;

  if (debug)
    printf("mangling_memfrob: starting getstate\n");

  ret = malloc(sizeof(struct mangling_memfrob_state));

  ret->debug = debug;

  if (debug)
    printf("mangling_memfrob: successful getstate\n");

  return ret;
}

char *mangling_memfrob_LTX_mangle_message(void *mangling_state,char *buf,int incount,int *outcount){
  char *newbuf;
  struct mangling_memfrob_state *state = mangling_state;

  if (state->debug)
    printf("mangling_memfrob: start mangle_message\n");

  newbuf = malloc(incount);
  bcopy(buf,newbuf,incount);
  *outcount = incount;
  memfrob(newbuf,incount);

  if (state->debug)
    printf("mangling_memfrob: successful mangle_message\n");
  
  return newbuf;
}

char *mangling_memfrob_LTX_unmangle_message(void *mangling_state,char *buf,int incount,int *outcount){
  char *newbuf;
  struct mangling_memfrob_state *state = mangling_state;

  if (state->debug)
    printf("mangling_memfrob: start unmangle_message\n");

  newbuf = malloc(incount);
  bcopy(buf,newbuf,incount);
  *outcount = incount;
  memfrob(newbuf,incount);

  if (state->debug)
    printf("mangling_memfrob: successful unmangle_message\n");
  
  return newbuf;
} 

int mangling_memfrob_LTX_mangling_close(void *state){
  free(state);
  return 0;
}
